package myfirstejb;

import javax.naming.*;
import javax.rmi.PortableRemoteObject;

public class SaisenbakoBeanClient {
  private static final String ERROR_NULL_REMOTE = "Remote C^[tF[XQƂ null łB  ŏHome C^[tF[X\bĥЂƂĂяoāA쐬Kv܂B";
  private static final int MAX_OUTPUT_LINE_LENGTH = 50;
  private boolean logging = true;
  private SaisenbakoHome saisenbakoHome = null;
  private Saisenbako saisenbako = null;

  /**EJB eXgNCAg̍\z*/
  public SaisenbakoBeanClient() {
    long startTime = 0;
    if (logging) {
      log("Bean ANZX̏");
      startTime = System.currentTimeMillis();
    }

    try {
      //l[ReLXg̎擾
      Context ctx = new InitialContext();

      //jndi bNAbv
      Object ref = ctx.lookup("Saisenbako");

      //Home C^[tF[XɃLXg
      saisenbakoHome = (SaisenbakoHome) PortableRemoteObject.narrow(ref, SaisenbakoHome.class);
      if (logging) {
        long endTime = System.currentTimeMillis();
        log("Bean ANZX̏ɐ");
        log("s: " + (endTime - startTime) + " ms.");
      }
    }
    catch(Exception e) {
      if (logging) {
        log("Bean ANZX̏Ɏs܂");
      }
      e.printStackTrace();
    }
  }

  //----------------------------------------------------------------------------
  // [gC^[tF[Xւ̎QƂ𐶐 Home C^[tF[X\bhgp郁\bh
  //----------------------------------------------------------------------------

  public Saisenbako create() {
    long startTime = 0;
    if (logging) {
      log("Ăяo create()");
      startTime = System.currentTimeMillis();
    }
    try {
      saisenbako = saisenbakoHome.create();
      if (logging) {
        long endTime = System.currentTimeMillis();
        log(": create()");
        log("s: " + (endTime - startTime) + " ms.");
      }
    }
    catch(Exception e) {
      if (logging) {
        log("s: create()");
      }
      e.printStackTrace();
    }

    if (logging) {
      log("߂l: create(): " + saisenbako + ".");
    }
    return saisenbako;
  }

  //----------------------------------------------------------------------------
  // Bean ʂăf[^ɃANZX Remote C^[tF[X\bhgp郁\bh
  //----------------------------------------------------------------------------

  public void pay(double fee) {
    if (saisenbako == null) {
      System.out.println("G[: pay(): " + ERROR_NULL_REMOTE);
      return ;
    }
    long startTime = 0;
    if (logging) {
      log("Ăяo pay(" + fee + ")");
      startTime = System.currentTimeMillis();
    }

    try {
      saisenbako.pay(fee);
      if (logging) {
        long endTime = System.currentTimeMillis();
        log(": pay(" + fee + ")");
        log("s: " + (endTime - startTime) + " ms.");
      }
    }
    catch(Exception e) {
      if (logging) {
        log("s: pay(" + fee + ")");
      }
      e.printStackTrace();
    }
  }

  public double getAmount() {
    double returnValue = 0f;
    if (saisenbako == null) {
      System.out.println("G[: getAmount(): " + ERROR_NULL_REMOTE);
      return returnValue;
    }
    long startTime = 0;
    if (logging) {
      log("Ăяo getAmount()");
      startTime = System.currentTimeMillis();
    }

    try {
      returnValue = saisenbako.getAmount();
      if (logging) {
        long endTime = System.currentTimeMillis();
        log(": getAmount()");
        log("s: " + (endTime - startTime) + " ms.");
      }
    }
    catch(Exception e) {
      if (logging) {
        log("s: getAmount()");
      }
      e.printStackTrace();
    }

    if (logging) {
      log("߂l: getAmount(): " + returnValue + ".");
    }
    return returnValue;
  }

  //----------------------------------------------------------------------------
  // [eBeB \bh
  //----------------------------------------------------------------------------

  private void log(String message) {
    if (message.length() > MAX_OUTPUT_LINE_LENGTH) {
      System.out.println("-- " + message.substring(0, MAX_OUTPUT_LINE_LENGTH) + " ...");
    }
    else {
      System.out.println("-- " + message);
    }
  }
  /**Main \bh*/

  public static void main(String[] args) {
    SaisenbakoBeanClient client = new SaisenbakoBeanClient();
    //  Home C^[tF[Xbp[̂ЂƂĂяoɂ client IuWFNggp܂B
    // Bean ւ̃[gC^[tF[X̎QƂ쐬ł܂B
    // ߂l Remote C^[tF[X̌^łꍇ́A
    // p Remote C^[tF[X\bhɃANZXł܂B ܂AP
    // client IuWFNggp Remote C^[tF[Xbp[ĂяoƂł܂B
  }
}